<?php
if (!defined('SMF'))
	die('Hacking attempt...');

	TopicVisits_InstallSettings();
	TopicVisits_TableCreate();

function TopicVisits_InstallSettings()
{
	global $smcFunc;

	// Randem Systems - 20180326 - RJ - Start

	// Create all settings
	
	$TopicVisits_settings = array(
		array('show_topic_visits_file_download_stats', true),
		array('show_topic_visits_stats', true),
		array('delete_topic_visits_log_tables_on_uninstall', false),
		array('delete_topic_visits_settings_on_uninstall', false),
		array('days_to_keep_topic_visits_log_data', 30),
		array('last_date_of_topic_visits_log_pruning', date('Y/m/d', strtotime('now'))),
		array('delete_topic_visits_downloads_settings_on_uninstall', false),
		array('delete_topic_visits_downloads_log_table_on_uninstall', false)
		);
		
		foreach ($TopicVisits_settings as $setting){
			
			$request = $smcFunc['db_query']('',
					'Select value from {db_prefix}settings where variable = {string:variable}',
					array(
						'variable' => $setting[0])
					);
					
			if ($smcFunc['db_num_rows']($request) == 0) updateSettings(array($setting[0] => $setting[1]));		
		}
		
	// Randem Systems - 20180326 - RJ - End
}
function TopicVisits_TableCreate()
{
// Create the table we need to store the visitor's information so that we can track which boards & topics
// that they visit while they are on the forum. We only store unique information, so if a visitors visits
// the same board and topic several times it will only be counted as one visit for that visitor. This is the
// same not matter is the visitor is a member or a guest. This only needs to be done once, unless the tables
// are deleted. In that case the tables will automatically be recreated.

// Randem Systems - 20131217 - RJ - Start

	global $smcFunc, $db_name;

	db_extend('packages');


	//===================================================================================================================
	// Check to see if or log table exists, if not we will create it.
	//===================================================================================================================

	$result = $smcFunc['db_query']('', '
			SHOW TABLES LIKE \'{db_prefix}log_topic_visits_stats\'',
			array()
		);

	$table_exists = $smcFunc['db_num_rows']($result);

	if ($table_exists == 0)
	{
		// Create the Topic Stats main table used to hold all unique visits

		$db_columns = array(
				array(
						'name' => 'id_no',
						'type' => 'int',
						'size' => 10,
						'null' => false,
						'auto' => true
				),
				array(
						'name' => 'id_board',
						'type' => 'smallint',
						'size' => 5,
						'null' => false,
						'default' => 0
				),
				array(
						'name' => 'id_topic',
						'type' => 'int',
						'size' => 10,
						'null' => false,
						'default' => 0
				),
				array(
						'name' => 'id_member',
						'type' => 'mediumint',
						'size' => 8,
						'null' => false,
						'default' => 0
				),
				array(
						'name' => 'ip_addr',
						'type' => 'char',
						'size' => 16,
						'null' => false
				),
				array(
						'name' => 'rpt_date',
						'type' => 'date',
						'null' => false
				),
				array(
						'name' => 'http_user_agent',
						'type' => 'varchar',
						'size' => 1000,
						'null' => false
				),
				array(
						'name' => 'http_referer',
						'type' => 'char',
						'size' => 255,
						'null' => false
				),
				array(
						'name' => 'updated',
						'type' => 'timestamp',
						'null' => false
				)
		);

		$db_indexes = array(
				array(
						'name' => 'ID',
						'type' => 'primary',
						'columns' => array('id_no')
				),
				array(
						'name' => 'UniqueHits',
						'type' => 'unique',
						'columns' => array('id_board','id_topic','ip_addr','rpt_date')
				)
		);

		$smcFunc['db_create_table']('{db_prefix}log_topic_visits_stats' , $db_columns , $db_indexes , array() , 'ignore', 'fatal');

	}

//===================================================================================================================
// Create table to track downloads
//===================================================================================================================

// Randem Systems - 20131228 - RJ - Start

	$result = $smcFunc['db_query']('', '
		SHOW TABLES LIKE \'{db_prefix}log_topic_visits_downloads\'',
		array()
	);

	$table_exists = $smcFunc['db_num_rows']($result);

	if ($table_exists == 0)
	{
		$db_columns = array(
				array(
						'name' => 'id_attach',
						'type' => 'int',
						'size' => 10,
						'null' => false
				),
				array(
						'name' => 'updated',
						'type' => 'timestamp',
						'null' => false
				)
		);

		$smcFunc['db_create_table']('{db_prefix}log_topic_visits_downloads' , $db_columns , array() , array() , 'ignore', 'fatal');

		// Set the collation of all fields in this table

		$smcFunc['db_query']('', '
			ALTER TABLE {db_prefix}log_topic_visits_downloads convert to CHARACTER SET utf8 COLLATE utf8_general_ci');

	 }

// Randem Systems - 20131228 - RJ - End
}
?>