<?php
if (!defined('SMF'))
	die('Hacking attempt...');

// Randem Systems - RJ-20131218 - Start


//////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////

function GetTopicVisitStats()
{
	global $smcFunc,$context;

	GetTopicVisitDates();   // Get the topic visit dates that are in the table - Randem Systems - RJ-20131223

	$result = $smcFunc['db_query']('', '
		SHOW TABLES LIKE \'{db_prefix}log_topic_visits_stats\'',
		array()
	);

	$table_exists = $smcFunc['db_num_rows']($result);

	if ($table_exists > 0)
	{

		$params = $_GET;

		if (empty($params['rptdate']))
			$params['rptdate'] = date('Y-m-d');

		$paramString = http_build_query($params,'','&');
		$selected_date = $params['rptdate'];
		$context['topic_visits_rptdate'] = $selected_date;
		$context['topic_visits_report_url'] = $_SERVER['PHP_SELF'].'?'.$paramString;

		$query = "select count(`b`.`name`) AS `Hits`,`b`.`name` AS `Board`,`m`.`subject` AS `Topic` from
					(((`{db_prefix}log_topic_visits_stats` `p` left join `{db_prefix}topics` `t`
					on((`p`.`id_topic` = `t`.`id_topic`))) left join `{db_prefix}messages` `m`
					on((`t`.`id_first_msg` = `m`.`id_msg`))) left join `{db_prefix}boards` `b`
					on((`p`.`id_board` = `b`.`id_board`))) where (cast(`p`.`updated` as date) = {string:sdate})
					group by `b`.`name`,`m`.`subject`";

		$visit_result = $smcFunc['db_query']('',
							$query,
							array(
								'sdate' => $selected_date,
								)
		);

		$context['board_visits'] = array();
		while ($row_board = $smcFunc['db_fetch_assoc']($visit_result))
		{
			$context['board_visits'][] = array(
				'Hits' => $row_board['Hits'],
				'Board' => $row_board['Board'],
				'Topic' => $row_board['Topic']
			);

		}

		$smcFunc['db_free_result']($visit_result);

		(int)$context['topic_visits_total_hits'] = 0;

		foreach ($context['board_visits'] as $i => $row_board)
		{
			$context['board_visits'][$i]['Hits'] = comma_format((int) $row_board['Hits'],0);
			$context['board_visits'][$i]['Board'] = $row_board['Board'];
			$context['board_visits'][$i]['Topic'] = $row_board['Topic'];

			$context['topic_visits_total_hits'] = (int)$context['topic_visits_total_hits'] + (int)$row_board['Hits'];

		}

		GetTopicVisitsPerHour($selected_date);
		GetTopicVisitsFileDownloadCounts($selected_date);
		GetTopicVisitsDownloadsPerHour($selected_date);
	}

}

function GetTopicVisitsFileDownloadCounts($selected_date)
{
	global $smcFunc, $context;

	$result = $smcFunc['db_query']('', '
		SHOW TABLES LIKE \'{db_prefix}log_topic_visits_downloads\'',
		array()
	);

	$table_exists = $smcFunc['db_num_rows']($result);

	if ($table_exists > 0)
	{

		$query = 'Select a.filename as Filename, count(a.filename) as Downloads FROM `{db_prefix}log_topic_visits_downloads` `d`
					left join `{db_prefix}attachments` `a` on ((`d`.`id_attach` = `a`.`id_attach`))
					where (cast(d.updated as date) = {string:sdate})
					group by a.filename';

		$visit_result = $smcFunc['db_query']('',
							$query,
							array(
								'sdate' => $selected_date,
								)
		);

		$context['topic_visits_file_downloads'] = array();

		while ($row_board = $smcFunc['db_fetch_assoc']($visit_result))
		{
			$context['topic_visits_file_downloads'][] = array(
				'Filename' => $row_board['Filename'],
				'Downloads' => $row_board['Downloads']
			);

		}

		$smcFunc['db_free_result']($visit_result);

		(int)$context['topic_visits_total_downloads'] = 0;

		foreach ($context['topic_visits_file_downloads'] as $i => $row_board)
		{
			$context['topic_visits_file_downloads'][$i]['Filename'] = $row_board['Filename'];
			$context['topic_visits_file_downloads'][$i]['Downloads'] = comma_format((int) $row_board['Downloads'],0);

			$context['topic_visits_total_downloads'] = (int)$context['topic_visits_total_downloads'] + (int)$row_board['Downloads'];

		}
	}

}
//////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////

function GetTopicVisitsPerHour($selecteddate)
{
	global $smcFunc,$context;

	$query = "Select Count(ip_addr) as Hits, hour(updated) as Segment from {db_prefix}log_topic_visits_stats where cast(updated as date) = {string:sdate}  group by hour(updated)";

	$segment_result = $smcFunc['db_query']('',
						$query,
						array(
							'sdate' => $selecteddate,
							)
	);

	$context['hourly_visits'] = array();
	while ($row_board = $smcFunc['db_fetch_assoc']($segment_result))
	{
		$context['hourly_visits'][] = array(
			'Hits' => $row_board['Hits'],
			'Segment' => $row_board['Segment'],
		);

	}

	foreach ($context['hourly_visits'] as $i => $row_board)
	{
		$context['hourly_visits'][$i]['Segment'] = $row_board['Segment'];
		$context['hourly_visits'][$i]['Hits'] = $row_board['Hits'];
	}

	$smcFunc['db_free_result']($segment_result);

}

//////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////

function GetTopicVisitDates()
{
	global $smcFunc,$context;


	$result = $smcFunc['db_query']('', '
		SHOW TABLES LIKE \'{db_prefix}log_topic_visits_stats\'',
		array()
	);

	$table_exists = $smcFunc['db_num_rows']($result);

	if ($table_exists > 0)
	{
		// Get topics visited dates.

		$date_result = $smcFunc['db_query']('', '
			Select distinct cast( updated as date ) as report_date from {db_prefix}log_topic_visits_stats
			order by report_date',
			array()
		);

		$context['topic_visits_rpt_dates'] = array();
		while ($row_date = $smcFunc['db_fetch_assoc']($date_result))
		{
			$context['topic_visits_rpt_dates'][] = array(
				'report_date' => $row_date['report_date']
			);
		}

		$smcFunc['db_free_result']($date_result);

		foreach ($context['topic_visits_rpt_dates'] as $i => $row_date)
		{
			$context['topic_visits_rpt_dates'][$i]['report_date'] = $row_date['report_date'];
		}

	}
}

//////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////

function GetTopicVisitsDownloadsPerHour($selected_date)
{
	global $smcFunc,$context,$modSettings;

	// Disable security checks that $smcFunc uses for this query only
	// $smcFunc will not process sub Select clauses

	if (empty($modSettings['disableQueryCheck']))
		$modSettings['disableQueryCheck'] = false;

	$disableQueryCheckBack = $modSettings['disableQueryCheck'];

	$modSettings['disableQueryCheck'] = true;

	$query = "Select  a.Segment as Segment, Count(a.Segment) as Downloads from
				(Select hour(`updated`) as Segment FROM {db_prefix}log_topic_visits_downloads
				   where (cast(`updated` as date) = {string:sdate})) `a`
							group by Segment";

	$segment_result = $smcFunc['db_query']('',
						$query,
						array(
							'sdate' => $selected_date,
							)
	);

	// Re-enable $smcFunc security checks

	$modSettings['disableQueryCheck'] = $disableQueryCheckBack;

	$context['topic_visits_downloads'] = array();
	while ($row_board = $smcFunc['db_fetch_assoc']($segment_result))
	{
		$context['topic_visits_downloads'][] = array(
			'Downloads' => $row_board['Downloads'],
			'Segment' => $row_board['Segment'],
		);

	}

	foreach ($context['topic_visits_downloads'] as $i => $row_board)
	{
		$context['topic_visits_downloads'][$i]['Segment'] = $row_board['Segment'];
		$context['topic_visits_downloads'][$i]['Downloads'] = $row_board['Downloads'];
	}

	$smcFunc['db_free_result']($segment_result);

}
// Randem Systems - RJ-20131218 - End

?>